# About nom.tam.fits

The text of this page is released under the Creative Commons Zero Waiver 1.0

__nom.tam.fits__ is a full-featured, fast, 100% pure Java library for reading, writing, and modifying 
[FITS files](https://fits.gsfc.nasa.gov/fits_standard.html). The library owes its origins to Thomas A. McGlynn (hence 
the _nom.tam_ prefix) at [NASA Goddard Space Flight Center](https://www.nasa.gov/goddard/). Currently, it is 
maintained by Attila Kov&aacute;cs at the [Center for Astrophysics | Harvard & Smithsonian](https://cfa.harvard.edu/).

 - [Releases](https://github.com/nom-tam-fits/nom-tam-fits/releases)
 - [API Documentation](https://nom-tam-fits.github.io/nom-tam-fits/apidocs/index.html)
 - [User's Guide](https://nom-tam-fits.github.io/nom-tam-fits/README.html)
 - [Changes](https://nom-tam-fits.github.io/nom-tam-fits/CHANGELOG.html)
 - [Discussions](https://github.com/nom-tam-fits/nom-tam-fits/discussions) for questions, suggestions, comments.
 - Check or report known [Issues](https://github.com/nom-tam-fits/nom-tam-fits/issues)
 - [GitHub Repository](https://github.com/nom-tam-fits/nom-tam-fits/)
 - [Maven Central Repository](https://mvnrepository.com/artifact/gov.nasa.gsfc.heasarc/nom-tam-fits)
 - [Contributor's guide](https://nom-tam-fits.github.io/nom-tam-fits/CONTRIBUTING.html)


## About FITS

FITS is the Flexible Image Transport System, a file format designed at NASA for astronomical images and datasets. 
Despite its venerable age, the format is still being used today, including for disciplines outside of astrophysics.
 
  - [The FITS Standard](https://fits.gsfc.nasa.gov/fits_standard.html)
  - [Registered conventions](https://fits.gsfc.nasa.gov/fits_conventions.html)
  - [Reserved and conventional FITS keywords](https://fits.gsfc.nasa.gov/fits_dictionary.html)
  - [List of Software Libraries](https://fits.gsfc.nasa.gov/fits_libraries.html)
  - [FITS viewer applications](https://fits.gsfc.nasa.gov/fits_viewer.html)
